﻿@Component
export default class BombControl extends Script {

    protected onStart(): void {

        // 服务端运行
        if (SystemUtil.isServer()) {

            // 服务端五秒钟后销毁炸弹预制体
            setTimeout(() => {
                this.gameObject.destroy();
            }, 5000);

            // 三秒后检测炸弹200单位范围内有无玩家
            setTimeout(() => {
                // 范围检测
                const gameObjects = QueryUtil.sphereOverlap(this.gameObject.worldTransform.position, 200, true);
                //对物体进行遍历
                gameObjects.forEach(object => {
                    //判断当前遍历的物体是不是玩家角色
                    if (object instanceof Character) {
                        //我们给玩家发受伤消息
                        Event.dispatchToClient(object.player, "Event_HpChange");
                    }
                })
            }, 3000);

        }

        // 客户端运行
        if (SystemUtil.isClient()) {
            // 三秒后隐藏炸弹特效，播放爆炸特效，播放音效
            setTimeout(() => {
                // 隐藏炸弹特效
                const bombEffect = this.gameObject.getChildByName("炸弹") as Effect;
                bombEffect.setVisibility(false);
                // 显示爆炸特效
                const explodeEffect = this.gameObject.getChildByName("炸弹爆炸") as Effect;
                explodeEffect.loop = false;
                explodeEffect.play();
                // 播放音效
                const explodeSound = this.gameObject.getChildByName("火炮爆炸") as Sound;
                explodeSound.play();
            }, 2000);
        }
    }
}