﻿import CtrlUI_Generate from "./ui-generate/CtrlUI_generate";

export default class CtrlUI extends CtrlUI_Generate {

	//释放炸弹 cd，主要用来计时并控制 1 秒内允许释放一个炸弹
	timer: number = 0;

	/** 
	 * 构造UI文件成功后，在合适的时机最先初始化一次 
	 */
	protected onStart() {
		//设置能否每帧触发onUpdate
		this.canUpdate = false;
		this.layer = UILayerMiddle;

		this.mAttackBtn.onClicked.add(() => {
			this.onClickAttackBtn();
		});

		this.mJumpBtn.onClicked.add(() => {
			Player.asyncGetLocalPlayer().then((player) => {
				// 让玩家进行跳跃
				player.character.jump();
			});
		});

	}

	/**
	 * 使用炸弹
	 */
	private onClickAttackBtn() {
		if (this.timer == 0) {
			//重置倒计时为 1000
			this.timer = 1000;
			//通知服务器玩家释放了炸弹
			Event.dispatchToServer("Event_Bomb");
			//开始倒计时
			setTimeout(() => {
				//倒计时到期后设置时间
				this.timer = 0;
			}, this.timer);
		}
	}

}