﻿import CtrlUI from "./CtrlUI";
import HPbarUI from "./HPbarUI";

@Component
export default class GameStart extends Script {

    /** 当脚本被实例后，会在第一帧更新前调用此函数 */
    protected onStart(): void {

        if (SystemUtil.isClient()) {
            UIService.show(CtrlUI);
            UIService.show(HPbarUI);
        }

        if (SystemUtil.isServer()) {
            // player 参数为发送这个事件来的客户端玩家
            Event.addClientListener("Event_Bomb", (player: Player) => {
                // 下一行函数需要填入预制体 assetId ，请在工程内容中右键预制体 获取 工程内容ID
                const bombObj = GameObject.spawn("849EA4A3409AAED5645DC78B1B19F1A6");
                // 将炸弹位置设置为玩家位置
                bombObj.worldTransform.position = player.character.worldTransform.position;
            });
        }
    }
}